pipeline {
  agent any
    
  tools {nodejs "node"}
    
  stages {
        
        
    stage('Installations') {
      steps {
        sh 'npm install'
      }
    }
     
    stage('Build') {
      steps {
         sh 'docker build -t salmanhaider/node-img .'
      }
    }
    stage('Deployment') {
      steps {
        withDockerRegistry([ credentialsId: "0060e500-91fa-41f7-bdc3-10b5befb47d5", url: "" ]) {
          sh 'docker push salmanhaider/node-img'
        }
      }
    }      
  }
  post {
	 always {
	   sh 'echo "This will always run...."'
	 }
	 success {
	  emailext (
      subject: "FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]'",
      body: """<p>FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]':</p>
        <p>Check console output at &QUOT;<a href='${env.BUILD_URL}'>${env.JOB_NAME} [${env.BUILD_NUMBER}]</a>&QUOT;</p>""",
      recipientProviders: [[$class: 'DevelopersRecipientProvider']]
    )
	 }
	 failure {
	  emailext (
      subject: "FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]'",
      body: """<p>FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]':</p>
        <p>Check console output at &QUOT;<a href='${env.BUILD_URL}'>${env.JOB_NAME} [${env.BUILD_NUMBER}]</a>&QUOT;</p>""",
      recipientProviders: [[$class: 'DevelopersRecipientProvider']]
    )
	 }
	 unstable {
	  sh 'echo "This will run only if the run was marked as unstable..."'
	 }
	 changed {
	  sh 'echo "This will run only if the state of the Pipeline has changed"'
	  sh 'echo "For example, the Pipeline was previously failing but is now successful"'
	  sh 'echo ".... or the other way around :)"'
	 }
	}
}